diff --git a/yumcommands.py b/yumcommands.py
index 4dcbea7..b610f3a 100644
--- a/yumcommands.py
+++ b/yumcommands.py
@@ -1505,33 +3190,1745 @@ class CheckRpmdbCommand(YumCommand):
         return rc, ['%s %s' % (basecmd, chkcmd)]
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return False
 
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'read-only:past'
+
+
 class LoadTransactionCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    load-transaction command.
+    """
+
     def getNames(self):
-        return ['load-transaction', 'load-ts']
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return ['load-transaction', 'load-ts', 'ts-load']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "filename"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("load a saved transaction from filename")
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+        def _pkg_avail(l):
+            if not l.startswith('mbr:'):
+                return True # Kind of ... 
+
+            try:
+                pkgtup, current_state = l.split(':')[1].strip().split(' ')
+                current_state = int(current_state.strip())
+                pkgtup = tuple(pkgtup.strip().split(','))
+                if current_state == yum.TS_INSTALL:
+                    po = base.getInstalledPackageObject(pkgtup)
+                elif current_state == yum.TS_AVAILABLE:
+                    po = base.getPackageObject(pkgtup)
+                else:
+                    return False # Bad...
+            except:
+                return False # Bad...
+
+            return True
+        def _pkg_counts(l, counts):
+            if not l.startswith('  ts_state: '):
+                return
+            state = l[len('  ts_state: '):]
+            if state in ('e', 'od', 'ud'):
+                counts['remove'] += 1
+            elif state in ('i', 'u'):
+                counts['install'] += 1
+
         if not extcmds:
-            base.logger.critical(_("No saved transaction file specified."))
-            raise cli.CliError
+            extcmds = [tempfile.gettempdir()]
         
         load_file = extcmds[0]
+
+        if os.path.isdir(load_file):
+            self.doneCommand(base, _("showing transaction files from %s") %
+                             load_file)
+            yumtxs = sorted(glob.glob("%s/*.yumtx" % load_file))
+            currpmv = None
+            done = False
+            for yumtx in yumtxs:
+                data = base._load_ts_data(yumtx)
+                if data[0] is not None:
+                    continue # Bad file...
+                data = data[1]
+
+                rpmv = data[0].strip()
+                if currpmv is None:
+                    currpmv = str(base.rpmdb.simpleVersion(main_only=True)[0])
+                if rpmv == currpmv:
+                    current = _('y')
+                else:
+                    current = ' ' # Not usable is the most common
+
+                # See load_ts() for data ...
+                try:
+                    numrepos = int(data[2].strip())
+                    pkgstart = 3+numrepos
+                    numpkgs  = int(data[pkgstart].strip())
+                    pkgstart += 1
+                except:
+                    continue
+
+                counts = {'install' : 0, 'remove' : 0}
+                for l in data[pkgstart:]:
+                    l = l.rstrip()
+                    _pkg_counts(l, counts)
+
+                # Check to see if all the packages are available..
+                bad = ' '
+                for l in data[pkgstart:]:
+                    l = l.rstrip()
+                    if _pkg_avail(l):
+                        continue
+
+                    bad = '*'
+                    break
+
+                # assert (counts['install'] + counts['remove']) == numpkgs
+                current = '%s%s' % (bad, current)
+                if not done:
+                    pkgititle = _("Install")
+                    pkgilen = utf8_width(pkgititle)
+                    if pkgilen < 6:
+                        pkgilen = 6
+                    pkgititle = utf8_width_fill(pkgititle, pkgilen)
+
+                    pkgetitle = _("Remove")
+                    pkgelen = utf8_width(pkgetitle)
+                    if pkgelen < 6:
+                        pkgelen = 6
+                    pkgetitle = utf8_width_fill(pkgetitle, pkgelen)
+                    print "?? |", pkgititle, "|", pkgetitle, "|", _("Filename")
+                    
+                    done = True
+
+                numipkgs = locale.format("%d", counts['install'], True)
+                numipkgs = "%*s" % (pkgilen, numipkgs)
+                numepkgs = locale.format("%d", counts['remove'], True)
+                numepkgs = "%*s" % (pkgelen, numepkgs)
+                print "%s | %s | %s | %s" % (current, numipkgs, numepkgs,
+                                             os.path.basename(yumtx))
+            return 0, [_('Saved transactions from %s; looked at %u files') %
+                       (load_file, len(yumtxs))]
+
         self.doneCommand(base, _("loading transaction from %s") % load_file)
         
-        try:
-            base.load_ts(load_file)
-        except yum.Errors.YumBaseError, e:
-            return 1, [to_unicode(e)]
+        base.load_ts(load_file)
         return 2, [_('Transaction loaded from %s with %s members') % (load_file, len(base.tsInfo.getMembers()))]
 
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
+        if not extcmds or os.path.isdir(extcmds[0]):
+            return False
+
+        return True
+
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        if not extcmds or os.path.isdir(extcmds[0]):
+            return 'read-only:past'
+
+        return 'write'
+
+
+class SwapCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    swap command.
+    """
+
+    def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return ['swap']
+
+    def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
+        return "[remove|cmd] <pkg|arg(s)> [-- install|cmd] <pkg|arg(s)>"
+
+    def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
+        return _("Simple way to swap packages, instead of using shell")
+
+    def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that the program is being run by the root user,
+        that there are enabled repositories with gpg keys, and that
+        this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
+        checkRootUID(base)
+        checkGPGKey(base)
+        checkSwapPackageArg(base, basecmd, extcmds)
+        checkEnabledRepo(base, extcmds)
+
+    def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+
+        if '--' in extcmds:
+            off = extcmds.index('--')
+            rextcmds = extcmds[:off]
+            iextcmds = extcmds[off+1:]
+        else:
+            rextcmds = extcmds[:1]
+            iextcmds = extcmds[1:]
+
+        if not (rextcmds and iextcmds):
+            return 1, ['swap'] # impossible
+
+        if rextcmds[0] not in base.yum_cli_commands:
+            rextcmds = ['remove'] + rextcmds
+        if iextcmds[0] not in base.yum_cli_commands:
+            iextcmds = ['install'] + iextcmds
+
+        # Very similar to what the shell command does...
+        ocmds = base.cmds
+        oline = base.cmdstring
+        for cmds in (rextcmds, iextcmds):
+            base.cmdstring = " ".join(cmds)
+            base.cmds = cmds
+            #  Don't call this atm. as the line has gone through it already,
+            # also makes it hard to do the "is ?extcmds[0] a cmd" check.
+            # base.plugins.run('args', args=base.cmds)
+
+            # We don't catch exceptions, just pass them up and fail...
+            base.parseCommands()
+            cmdret = base.doCommands()
+            if cmdret[0] != 2:
+                return cmdret[0], ['%s %s' % (basecmd, " ".join(cmds))]
+        base.cmds      = ocmds
+        base.cmdstring = oline
+
+        return 2, ['%s %s' % (basecmd, " ".join(extcmds))]
+
+
+class RepoPkgsCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    repo command.
+    """
+
+    def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return ['repo-pkgs',
+                'repo-packages', 'repository-pkgs', 'repository-packages']
+
+    def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
+        return "<repoid> <list|info|install|remove|upgrade|reinstall*|remove-or-*> [pkg(s)]"
+
+    def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
+        return _("Treat a repo. as a group of packages, so we can install/remove all of them")
+
+    def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that the program is being run by the root user,
+        that there are enabled repositories with gpg keys, and that
+        this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
+        if len(extcmds) < 2: # <repoid> install|remove [pkgs]
+            base.logger.critical(
+                    _('Error: Need to pass a repoid. and command to %s') % basecmd)
+            _err_mini_usage(base, basecmd)
+            raise cli.CliError
+        if extcmds[1] not in ('info', 'list'):
+            checkRootUID(base)
+        checkGPGKey(base)
+        self.repoid = checkRepoPackageArg(base, basecmd, extcmds)
+
+    def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+
+        def _add_repopkg2txmbrs(txmbrs, repoid):
+            for txmbr in txmbrs:
+                txmbr.repopkg = repoid
+
+        repoid = self.repoid
+        cmd = extcmds[1]
+        args = extcmds[2:]
+        noargs = False
+        if not args:
+            noargs = True
+            args = ['*']
+        num = 0
+
+        remap = {'erase' : 'remove',
+                 'erase-or-reinstall' : 'remove-or-reinstall',
+                 'erase-or-sync' : 'remove-or-sync',
+                 'erase-or-distro-sync' : 'remove-or-sync',
+                 'remove-or-distro-sync' : 'remove-or-sync',
+                 'erase-or-distribution-synchronization' : 'remove-or-sync',
+                 'remove-or-distribution-synchronization' : 'remove-or-sync',
+                 'upgrade' : 'update', # Hack, but meh.
+                 'upgrade-to' : 'update-to', # Hack, but meh.
+                 'check-upgrade' : 'check-update', # Hack, but meh.
+                 'check-upgrades' : 'check-update', # Hack, but meh.
+                 'check-updates' : 'check-update', # Hack, but meh.
+                 }
+        cmd = remap.get(cmd, cmd)
+
+        if False: pass
+        elif cmd == 'list': # list/info is easiest...
+            return ListCommand().doCommand(base, cmd, args, repoid=repoid)
+        elif cmd == 'info':
+            return InfoCommand().doCommand(base, cmd, args, repoid=repoid)
+        elif cmd == 'check-update':
+            return CheckUpdateCommand().doCommand(base, cmd, args,repoid=repoid)
+
+        elif cmd == 'install': # install is simpler version of installPkgs...
+            for arg in args:
+                txmbrs = base.install(pattern=arg, repoid=repoid)
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+
+            if num:
+                return 2, P_('%d package to install', '%d packages to install',
+                             num)
+
+        elif cmd == 'update': # update is basically the same as install...
+            for arg in args:
+                txmbrs = base.update(pattern=arg, repoid=repoid)
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+
+            if num:
+                updateinfo.remove_txmbrs(base)
+                return 2, P_('%d package to update', '%d packages to update',
+                             num)
+
+        elif cmd == 'update-to': # update is basically the same as install...
+            for arg in args:
+                txmbrs = base.update(pattern=arg, update_to=True, repoid=repoid)
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+
+            if num:
+                updateinfo.remove_txmbrs(base)
+                return 2, P_('%d package to update', '%d packages to update',
+                             num)
+
+        elif cmd in ('reinstall-old', 'reinstall-installed'):
+            #  We have to choose for reinstall, for "reinstall foo" do we mean:
+            # 1. reinstall the packages that are currently installed from "foo".
+            # 2. reinstall the packages specified to the ones from "foo"
+
+            # This is for installed.from_repo=foo
+            if noargs:
+                onot_found_a = base._not_found_a.copy()
+            for arg in args:
+                txmbrs = base.reinstall(pattern=arg,
+                                        repoid=repoid, repoid_install=repoid)
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+            if noargs:
+                base._not_found_a = onot_found_a
+
+            if num:
+                return 2, P_('%d package to reinstall',
+                             '%d packages to reinstall', num)
+
+        elif cmd in ('reinstall-new', 'reinstall-available', 'move-to'):
+            # This is for move-to the packages from this repo.
+            if noargs:
+                onot_found_a = base._not_found_a.copy()
+            for arg in args:
+                txmbrs = base.reinstall(pattern=arg, repoid_install=repoid)
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+            if noargs:
+                base._not_found_a = onot_found_a
+
+            if num:
+                return 2, P_('%d package to move to',
+                             '%d packages to move to', num)
+
+        elif cmd == 'reinstall':
+            #  This means "guess", so doing the old version unless it produces
+            # nothing, in which case try switching.
+            if noargs:
+                onot_found_a = base._not_found_a.copy()
+            for arg in args:
+                try:
+                    txmbrs = base.reinstall(pattern=arg,
+                                            repoid=repoid,repoid_install=repoid)
+                except yum.Errors.ReinstallRemoveError:
+                    continue
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+            if noargs:
+                base._not_found_a = onot_found_a.copy()
+
+            if num:
+                return 2, P_('%d package to reinstall',
+                             '%d packages to reinstall', num)
+
+            for arg in args:
+                txmbrs = base.reinstall(pattern=arg, repoid_install=repoid)
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+            if noargs:
+                base._not_found_a = onot_found_a
+
+            if num:
+                return 2, P_('%d package to move to',
+                             '%d packages to move to', num)
+
+        elif cmd == 'remove': # Also mostly the same...
+            for arg in args:
+                txmbrs = base.remove(pattern=arg, repoid=repoid)
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+
+            if num:
+                return 2, P_('%d package to remove', '%d packages to remove',
+                             num)
+
+        elif cmd == 'remove-or-reinstall': # More complicated...
+            for arg in args:
+                txmbrs = base.remove(pattern=arg, repoid=repoid)
+                # Add an install() if it's in another repo.
+                for txmbr in txmbrs[:]:
+                    pkgs = base.pkgSack.searchPkgTuple(txmbr.pkgtup)
+                    for pkg in sorted(pkgs):
+                        if pkg.repoid == repoid:
+                            continue
+                        txmbrs += base.install(po=pkg)
+                        break
+
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+
+            if num:
+                return 2, P_('%d package to remove/reinstall',
+                             '%d packages to remove/reinstall', num)
+
+        elif cmd == 'remove-or-sync': # Even more complicated...
+            for arg in args:
+                txmbrs = base.remove(pattern=arg, repoid=repoid)
+                #  Add an install/upgrade/downgrade if a version is in another
+                # repo.
+                for txmbr in txmbrs[:]:
+                    pkgs = base.pkgSack.searchNames([txmbr.name])
+                    apkgs = []
+                    for pkg in sorted(pkgs):
+                        if pkg.repoid == repoid: # Backwards filter_pkgs_repoid
+                            continue
+                        if apkgs and pkg.verEQ(apkgs[0]):
+                            apkgs.append(pkg)
+                        else:
+                            apkgs = [pkg]
+
+                    if apkgs:
+                        for pkg in apkgs:
+                            if pkg.arch != txmbr.arch:
+                                continue
+                            apkgs = [pkg]
+                            break
+                        if len(apkgs) != 1:
+                            apkgs = base.bestPackagesFromList(apkgs)
+
+                    for toinst in apkgs:
+                        n,a,e,v,r = toinst.pkgtup
+                        if toinst.verEQ(txmbr.po):
+                            txmbrs += base.install(po=toinst)
+                        elif toinst.verGT(txmbr.po):
+                            txmbrs += base.update(po=toinst)
+                        else:
+                            base.tsInfo.remove(txmbr.pkgtup)
+                            txmbrs.remove(txmbr)
+                            txmbrs += base.downgrade(po=toinst)
+
+                _add_repopkg2txmbrs(txmbrs, repoid)
+                num += len(txmbrs)
+
+            if num:
+                return 2, P_('%d package to remove/sync',
+                             '%d packages to remove/sync', num)
+
+        else:
+            return 1, [_('Not a valid sub-command of %s') % basecmd]
+
+        return 0, [_('Nothing to do')]
+
+    def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
+        cmd = 'install'
+        if len(extcmds) > 1:
+            cmd = extcmds[1]
+        if cmd in ('info', 'list'):
+            return InfoCommand().needTs(base, cmd, extcmds[2:])
+
         return True
 
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        cmd = 'install'
+        if len(extcmds) > 1:
+            cmd = extcmds[1]
+        if cmd in ('info', 'list'):
+            return InfoCommand().cacheRequirement(base, cmd, extcmds[2:])
+        if cmd in ('check-update', 'check-upgrade',
+                   'check-updates', 'check-upgrades'):
+            return CheckUpdateCommand().cacheRequirement(base, cmd, extcmds[2:])
+        return 'write'
+
+# Using this a lot, so make it easier...
+_upi = updateinfo
+class UpdateinfoCommand(YumCommand):
+    # Old command names...
+    direct_cmds = {'list-updateinfo'    : 'list',
+                   'list-security'      : 'list',
+                   'list-sec'           : 'list',
+                   'info-updateinfo'    : 'info',
+                   'info-security'      : 'info',
+                   'info-sec'           : 'info',
+                   'summary-updateinfo' : 'summary'}
+
+    #  Note that this code (instead of using inheritance and multiple
+    # cmd classes) means that "yum help" only displays the updateinfo command.
+    # Which is what we want, because the other commands are just backwards
+    # compatible gunk we don't want the user using).
+    def getNames(self):
+        return ['updateinfo'] + sorted(self.direct_cmds.keys())
+
+    def getUsage(self):
+        return "[info|list|...] [security|...] [installed|available|all] [pkgs|id]"
+
+    def getSummary(self):
+        return "Acts on repository update information"
+
+    def doCheck(self, base, basecmd, extcmds):
+        pass
+
+    def list_show_pkgs(self, base, md_info, list_type, show_type,
+                       iname2tup, data, msg):
+        n_maxsize = 0
+        r_maxsize = 0
+        t_maxsize = 0
+        for (notice, pkgtup, pkg) in data:
+            n_maxsize = max(len(notice['update_id']), n_maxsize)
+            tn = notice['type']
+            if tn == 'security' and notice['severity']:
+                tn = notice['severity'] + '/Sec.'
+            t_maxsize = max(len(tn),                  t_maxsize)
+            if show_type:
+                for ref in _upi._ysp_safe_refs(notice['references']):
+                    if ref['type'] != show_type:
+                        continue
+                    r_maxsize = max(len(str(ref['id'])), r_maxsize)
+
+        for (notice, pkgtup, pkg) in data:
+            mark = ''
+            if list_type == 'all':
+                mark = '  '
+                if pkgtup[0] in iname2tup and _upi._rpm_tup_vercmp(iname2tup[pkgtup[0]], pkgtup) >= 0:
+                    mark = 'i '
+            tn = notice['type']
+            if tn == 'security' and notice['severity']:
+                tn = notice['severity'] + '/Sec.'
+
+            if show_type and _upi._ysp_has_info_md(show_type, notice):
+                for ref in _upi._ysp_safe_refs(notice['references']):
+                    if ref['type'] != show_type:
+                        continue
+                    msg("%s %-*s %-*s %s" % (mark, r_maxsize, str(ref['id']),
+                                             t_maxsize, tn, pkg))
+            elif hasattr(pkg, 'name'):
+                print base.fmtKeyValFill("%s: " % pkg.name,
+                                         base._enc(pkg.summary))
+            else:
+                msg("%s%-*s %-*s %s" % (mark, n_maxsize, notice['update_id'],
+                                        t_maxsize, tn, pkg))
+
+    def info_show_pkgs(self, base, md_info, list_type, show_type,
+                       iname2tup, data, msg):
+        show_pkg_info_done = {}
+        for (notice, pkgtup, pkg) in data:
+            if notice['update_id'] in show_pkg_info_done:
+                continue
+            show_pkg_info_done[notice['update_id']] = notice
+
+            if hasattr(notice, 'text'):
+                debug_log_lvl = yum.logginglevels.DEBUG_3
+                vlog = base.verbose_logger
+                if vlog.isEnabledFor(debug_log_lvl):
+                    obj = notice.text(skip_data=[])
+                else:
+                    obj = notice.text()
+            else:
+                # Python-2.4.* doesn't understand str(x) returning unicode
+                obj = notice.__str__()
+
+            if list_type == 'all':
+                if pkgtup[0] in iname2tup and _upi._rpm_tup_vercmp(iname2tup[pkgtup[0]], pkgtup) >= 0:
+                    obj = obj + "\n  Installed : true"
+                else:
+                    obj = obj + "\n  Installed : false"
+            msg(obj)
+
+    def summary_show_pkgs(self, base, md_info, list_type, show_type,
+                          iname2tup, data, msg):
+        def _msg(x):
+            base.verbose_logger.info("%s", x)
+        counts = {}
+        sev_counts = {}
+        show_pkg_info_done = {}
+        for (notice, pkgtup, pkg) in data:
+            if notice['update_id'] in show_pkg_info_done:
+                continue
+            show_pkg_info_done[notice['update_id']] = notice
+            counts[notice['type']] = counts.get(notice['type'], 0) + 1
+            if notice['type'] == 'security':
+                sev = notice['severity']
+                if sev is None:
+                    sev = ''
+                sev_counts[sev] = sev_counts.get(sev, 0) + 1
+
+        maxsize = 0
+        for T in ('newpackage', 'security', 'bugfix', 'enhancement'):
+            if T not in counts:
+                continue
+            size = len(str(counts[T]))
+            if maxsize < size:
+                maxsize = size
+        if not maxsize:
+            if base.conf.autocheck_running_kernel:
+                _upi._check_running_kernel(base, md_info, _msg)
+            return
+
+        outT = {'newpackage' : 'New Package',
+                'security' : 'Security',
+                'bugfix' : 'Bugfix',
+                'enhancement' : 'Enhancement'}
+        print "Updates Information Summary:", list_type
+        for T in ('newpackage', 'security', 'bugfix', 'enhancement'):
+            if T not in counts:
+                continue
+            n = outT[T]
+            if T == 'security' and len(sev_counts) == 1:
+                sn = sev_counts.keys()[0]
+                if sn != '':
+                    n = sn + " " + n
+            print "    %*u %s notice(s)" % (maxsize, counts[T], n)
+            if T == 'security' and len(sev_counts) != 1:
+                def _sev_sort_key(key):
+                    # We want these in order, from "highest" to "lowest".
+                    # Anything unknown is "higher". meh.
+                    return {'Critical' : "zz1",
+                            'Important': "zz2",
+                            'Moderate' : "zz3",
+                            'Low'      : "zz4",
+                            }.get(key, key)
+
+                for sn in sorted(sev_counts, key=_sev_sort_key):
+                    args = (maxsize, sev_counts[sn],sn or '?', outT['security'])
+                    print "        %*u %s %s notice(s)" % args
+        if base.conf.autocheck_running_kernel:
+            _upi._check_running_kernel(base, md_info, _msg)
+        self.show_pkg_info_done = {}
+
+    def _get_new_pkgs(self, md_info):
+        for notice in md_info.notices:
+            if notice['type'] != "newpackage":
+                continue
+            for upkg in notice['pkglist']:
+                for pkg in upkg['packages']:
+                    pkgtup = (pkg['name'], pkg['arch'], pkg['epoch'] or '0',
+                              pkg['version'], pkg['release'])
+                    yield (notice, pkgtup)
+
+    _cmd2filt = {"bugzillas" : "bugzilla",
+                 "bugzilla" : "bugzilla",
+                 "bzs" : "bugzilla",
+                 "bz" : "bugzilla",
+
+                 "sec" : "security",
+
+                 "cves" : "cve",
+                 "cve" : "cve",
+
+                 "newpackages" : "newpackage",
+                 "new-packages" : "newpackage",
+                 "newpackage" : "newpackage",
+                 "new-package" : "newpackage",
+                 "new" : "newpackage"}
+    for filt_type in _upi._update_info_types_:
+        _cmd2filt[filt_type] = filt_type
+
+    def doCommand(self, base, basecmd, extcmds):
+        if basecmd in self.direct_cmds:
+            subcommand = self.direct_cmds[basecmd]
+        elif extcmds and extcmds[0] in ('list', 'info', 'summary',
+                                        'remove-pkgs-ts', 'exclude-updates',
+                                        'exclude-all',
+                                        'check-running-kernel'):
+            subcommand = extcmds[0]
+            extcmds = extcmds[1:]
+        elif extcmds and extcmds[0] in self._cmd2filt:
+            subcommand = 'list'
+        elif extcmds:
+            subcommand = 'info'
+        else:
+            subcommand = 'summary'
+
+        if subcommand == 'list':
+            return self.doCommand_li(base, 'updateinfo list', extcmds,
+                                     self.list_show_pkgs)
+        if subcommand == 'info':
+            return self.doCommand_li(base, 'updateinfo info', extcmds,
+                                     self.info_show_pkgs)
+
+        if subcommand == 'summary':
+            return self.doCommand_li(base, 'updateinfo summary', extcmds,
+                                     self.summary_show_pkgs)
+
+        if subcommand == 'remove-pkgs-ts':
+            filters = None
+            if extcmds:
+                filters = updateinfo._args2filters(extcmds)
+            updateinfo.remove_txmbrs(base, filters)
+            return 0, [basecmd + ' ' + subcommand + ' done']
+
+        if subcommand == 'exclude-all':
+            filters = None
+            if extcmds:
+                filters = updateinfo._args2filters(extcmds)
+            updateinfo.exclude_all(base, filters)
+            return 0, [basecmd + ' ' + subcommand + ' done']
+
+        if subcommand == 'exclude-updates':
+            filters = None
+            if extcmds:
+                filters = updateinfo._args2filters(extcmds)
+            updateinfo.exclude_updates(base, filters)
+            return 0, [basecmd + ' ' + subcommand + ' done']
+
+        if subcommand == 'check-running-kernel':
+            def _msg(x):
+                base.verbose_logger.info("%s", x)
+            updateinfo._check_running_kernel(base, base.upinfo, _msg)
+            return 0, [basecmd + ' ' + subcommand + ' done']
+
+    def doCommand_li_new(self, base, list_type, extcmds, md_info, msg,
+                         show_pkgs, iname2tup):
+        done_pkgs = set()
+        data = []
+        for (notice, pkgtup) in sorted(self._get_new_pkgs(md_info),
+                                       key=lambda x: x[1][0]):
+            if extcmds and not _upi._match_sec_cmd(extcmds, pkgtup[0], notice):
+                continue
+            n = pkgtup[0]
+            if n in done_pkgs:
+                continue
+            ipkgs = list(reversed(sorted(base.rpmdb.searchNames([n]))))
+            if list_type in ('installed', 'updates') and not ipkgs:
+                done_pkgs.add(n)
+                continue
+            if list_type == 'available' and ipkgs:
+                done_pkgs.add(n)
+                continue
+
+            pkgs = base.pkgSack.searchPkgTuple(pkgtup)
+            if not pkgs:
+                continue
+            if list_type == "updates" and pkgs[0].verLE(ipkgs[0]):
+                done_pkgs.add(n)
+                continue
+            done_pkgs.add(n)
+            data.append((notice, pkgtup, pkgs[0]))
+        show_pkgs(base, md_info, list_type, None, iname2tup, data, msg)
+
+    def _parse_extcmds(self, extcmds):
+        filt_type = None
+        show_type = None
+        if len(extcmds) >= 1:
+            filt_type = None
+            
+            if extcmds[0] in self._cmd2filt:
+                filt_type = self._cmd2filt[extcmds.pop(0)]
+            show_type = filt_type
+            if filt_type and filt_type in _upi._update_info_types_:
+                show_type = None
+        return extcmds, show_type, filt_type
+
+    def doCommand_li(self, base, basecmd, extcmds, show_pkgs):
+        md_info = base.upinfo
+        def msg(x):
+            #  Don't use: logger.log(logginglevels.INFO_2, x)
+            # or -q deletes everything.
+            print x
+
+        opts = _upi._updateinfofilter2opts(base.updateinfo_filters)
+        extcmds, show_type, filt_type = self._parse_extcmds(extcmds)
+
+        list_type = "available"
+        if extcmds and extcmds[0] in ("updates","available","installed", "all"):
+            list_type = extcmds.pop(0)
+            if filt_type is None:
+                extcmds, show_type, filt_type = self._parse_extcmds(extcmds)
+
+        opts.sec_cmds = extcmds
+        used_map = _upi._ysp_gen_used_map(base.updateinfo_filters)
+        iname2tup = {}
+        if False: pass
+        elif list_type in ('installed', 'all'):
+            name2tup = _upi._get_name2allpkgtup(base)
+            iname2tup = _upi._get_name2instpkgtup(base)
+        elif list_type == 'updates':
+            name2tup = _upi._get_name2oldpkgtup(base)
+        elif list_type == 'available':
+            name2tup = _upi._get_name2instpkgtup(base)
+
+        if filt_type == "newpackage":
+            self.doCommand_li_new(base, list_type, extcmds, md_info, msg,
+                                  show_pkgs, iname2tup)
+            return 0, [basecmd + ' new done']
+
+        def _show_pkgtup(pkgtup):
+            name = pkgtup[0]
+            notices = reversed(md_info.get_applicable_notices(pkgtup))
+            for (pkgtup, notice) in notices:
+                if filt_type and not _upi._ysp_has_info_md(filt_type, notice):
+                    continue
+
+                if list_type == 'installed':
+                    # Remove any that are newer than what we have installed
+                    if _upi._rpm_tup_vercmp(iname2tup[name], pkgtup) < 0:
+                        continue
+
+                if _upi._ysp_should_filter_pkg(opts, name, notice, used_map):
+                    yield (pkgtup, notice)
+
+        data = []
+        for pkgname in sorted(name2tup):
+            for (pkgtup, notice) in _show_pkgtup(name2tup[pkgname]):
+                d = {}
+                (d['n'], d['a'], d['e'], d['v'], d['r']) = pkgtup
+                if d['e'] == '0':
+                    d['epoch'] = ''
+                else:
+                    d['epoch'] = "%s:" % d['e']
+                data.append((notice, pkgtup,
+                            "%(n)s-%(epoch)s%(v)s-%(r)s.%(a)s" % d))
+        show_pkgs(base, md_info, list_type, show_type, iname2tup, data, msg)
+
+        _upi._ysp_chk_used_map(used_map, msg)
+
+        return 0, [basecmd + ' done']
+
+
+class UpdateMinimalCommand(YumCommand):
+    def getNames(self):
+        return ['update-minimal', 'upgrade-minimal',
+                'minimal-update', 'minimal-upgrade']
+
+    def getUsage(self):
+        return "[PACKAGE-wildcard]"
+
+    def getSummary(self):
+        return _("Works like upgrade, but goes to the 'newest' package match which fixes a problem that affects your system")
+
+    def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that the program is being run by the root user,
+        that there are enabled repositories with gpg keys, and that
+        this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
+        checkRootUID(base)
+        checkGPGKey(base)
+
+    def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+
+        num = len(base.tsInfo)
+        _upi.update_minimal(base, extcmds)
+        num = len(base.tsInfo) - num
+        
+        if num > 0:
+            msg = '%d packages marked for minimal Update' % num
+            return 2, [msg]
+        else:
+            return 0, ['No Packages marked for minimal Update']
+
+
+class FSSnapshotCommand(YumCommand):
+    def getNames(self):
+        return ['fssnapshot', 'fssnap']
+
+    def getUsage(self):
+        return "[]"
+
+    def getSummary(self):
+        return _("Creates filesystem snapshots, or lists/deletes current snapshots.")
+
+    def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that the program is being run by the root user,
+        that there are enabled repositories with gpg keys, and that
+        this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
+        checkRootUID(base)
+
+    @staticmethod
+    def _li_snaps(base, snaps):
+        snaps = sorted(snaps, key=lambda x: x['dev'])
+
+        max_dev = utf8_width(_('Snapshot'))
+        max_ori = utf8_width(_('Origin'))
+        for data in snaps:
+            max_dev = max(max_dev, len(data['dev']))
+            max_ori = max(max_ori, len(data['origin']))
+
+        done = False
+        for data in snaps:
+            if not done:
+                print ("%s %s %s %s %s %s" %
+                       (utf8_width_fill(_('Snapshot'), max_dev),
+                        utf8_width_fill(_('Size'), 6, left=False),
+                        utf8_width_fill(_('Used'), 6, left=False),
+                        utf8_width_fill(_('Free'), 6, left=False),
+                        utf8_width_fill(_('Origin'), max_ori), _('Tags')))
+                done = True
+            print ("%*s %6s %5.1f%% %6s %*s %s" %
+                   (max_dev, data['dev'], base.format_number(data['size']),
+                    data['used'],
+                    base.format_number(data['free']),
+                    max_ori, data['origin'], ",".join(data['tags'])))
+
+    def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+        if extcmds and extcmds[0] in ('list', 'delete', 'create', 'summary',
+                                      'have-space', 'has-space'):
+            subcommand = extcmds[0]
+            extcmds = extcmds[1:]
+        else:
+            subcommand = 'summary'
+
+        if not base.fssnap.available:
+            if not base.rpmdb.searchNames(['python-lvm']):
+                print _("Snapshot support not available, no python-lvm package installed.")
+            else:
+                print _("Snapshot support not available, python-lvm is old/broken.")
+            return 0, [basecmd + ' ' + subcommand + ' done']
+
+        if subcommand == 'list':
+            snaps = base.fssnap.old_snapshots()
+            print _("List of %u snapshosts:") % len(snaps)
+            self._li_snaps(base, snaps)
+
+        if subcommand == 'delete':
+            snaps = base.fssnap.old_snapshots()
+            devs = [x['dev'] for x in snaps]
+            snaps = set()
+            for dev in devs:
+                if dev in snaps:
+                    continue
+
+                for extcmd in extcmds:
+                    if dev == extcmd or fnmatch.fnmatch(dev, extcmd):
+                        snaps.add(dev)
+                        break
+            snaps = base.fssnap.del_snapshots(devices=snaps)
+            print _("Deleted %u snapshosts:") % len(snaps)
+            self._li_snaps(base, snaps)
+
+        if subcommand in ('have-space', 'has-space'):
+            pc = base.conf.fssnap_percentage
+            if base.fssnap.has_space(pc):
+                print _("Space available to take a snapshot.")
+            else:
+                print _("Not enough space available to take a snapshot.")
+
+        if subcommand == 'create':
+            tags = {'*': ['reason=manual']}
+            pc = base.conf.fssnap_percentage
+            for (odev, ndev) in base.fssnap.snapshot(pc, tags=tags):
+                print _("Created snapshot from %s, results is: %s") %(odev,ndev)
+            else:
+                print _("Failed to create snapshots")
+
+        if subcommand == 'summary':
+            snaps = base.fssnap.old_snapshots()
+            if not snaps:
+                print _("No snapshots, LVM version:"), base.fssnap.version
+                return 0, [basecmd + ' ' + subcommand + ' done']
+
+            used = 0
+            dev_oris = set()
+            for snap in snaps:
+                used += snap['used']
+                dev_oris.add(snap['origin_dev'])
+
+            msg = _("Have %u snapshots, using %s space, from %u origins.")
+            print msg % (len(snaps), base.format_number(used), len(dev_oris))
+
+        return 0, [basecmd + ' ' + subcommand + ' done']
+
+
+class FSCommand(YumCommand):
+    def getNames(self):
+        return ['fs']
+
+    def getUsage(self):
+        return "[]"
+
+    def getSummary(self):
+        return _("Acts on the filesystem data of the host, mainly for removing docs/lanuages for minimal hosts.")
+
+    def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that the program is being run by the root user,
+        that there are enabled repositories with gpg keys, and that
+        this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
+        if extcmds and extcmds[0] in ('du', 'status', 'diff'):
+            # Anyone can go for it...
+            return
+
+        if len(extcmds) == 1 and extcmds[0] in ('filters', 'filter'):
+            # Can look, but not touch.
+            return
+
+        checkRootUID(base)
+
+    def _fs_pkg_walk(self, pkgs, prefix, modified=False, verbose=False):
+
+        pfr = {'norm' : {},
+               'mod' : {},
+               'ghost' : {},
+               'miss' : {},
+               'not' : {}
+               }
+
+        def quick_match(pkgs):
+            for pkg in pkgs:
+                for fname in pkg.filelist + pkg.dirlist:
+                    if not fname.startswith(prefix):
+                        continue
+                    pfr['norm'][fname] = pkg
+                for fname in pkg.ghostlist:
+                    if not fname.startswith(prefix):
+                        continue
+                    pfr['ghost'][fname] = pkg
+            return pfr
+
+        def _quick_match_iter(pkgs):
+            # Walking the fi information is much slower than filelist/dirlist
+            for pkg in pkgs:
+                found = False
+                for fname in pkg.dirlist:
+                    if fname.startswith(prefix):
+                        yield pkg
+                        found = True
+                        break
+                if found:
+                    continue
+                for fname in pkg.filelist:
+                    if fname.startswith(prefix):
+                        yield pkg
+                        found = True
+                        break
+                if found:
+                    continue
+                for fname in pkg.ghostlist:
+                    if fname.startswith(prefix):
+                        yield pkg
+                        break
+
+        def verify_match(pkgs):
+            _pfs = []
+            def scoop_pfs(pfs):
+                _pfs.append(pfs)
+
+                if not modified:
+                    return []
+
+                return pfs
+
+            if prefix != '/':
+                pkgs = _quick_match_iter(pkgs)
+            for pkg in pkgs:
+                _pfs = []
+                probs = pkg.verify(patterns=[prefix+'*'], fake_problems=False,
+                                   callback=scoop_pfs, failfast=True)
+
+                for pf in _pfs[0]:
+                    if pf.filename in probs:
+                        pfr['mod'][pf.filename] = pkg
+                    elif pf.rpmfile_state == 'not installed':
+                        pfr['not'][pf.filename] = pkg
+                    elif 'ghost' in pf.rpmfile_types:
+                        pfr['ghost'][pf.filename] = pkg
+                    elif 'missing ok' in pf.rpmfile_types:
+                        pfr['miss'][pf.filename] = pkg
+                    else:
+                        pfr['norm'][pf.filename] = pkg
+            return pfr
+
+        # return quick_match(pkgs)
+        return verify_match(pkgs)
+
+    def _fs_du(self, base, extcmds):
+        def _dir_prefixes(path):
+            while path != '/':
+                path = os.path.dirname(path)
+                yield path
+
+        def loc_num(x):
+            """ String of a number in the readable "locale" format. """
+            return locale.format("%d", int(x), True)
+
+        data = {'pkgs_size' : {},
+                'pkgs_not_size' : {},
+                'pkgs_ghost_size' : {},
+                'pkgs_miss_size' : {},
+                'pkgs_mod_size' : {},
+
+                'pres_size' : {},
+                'data_size' : {},
+                'data_not_size' : {},
+
+                'pkgs_count' : 0,
+                'pkgs_not_count' : 0,
+                'pkgs_ghost_count' : 0,
+                'pkgs_miss_count' : 0,
+                'pkgs_mod_count' : 0,
+
+                'data_count' : 0} # data_not_count == pkgs_not_count
+
+        def _add_size(d, v, size):
+            if v not in d:
+                d[v] = 0
+            d[v] += size
+
+        def deal_with_file(fpath, need_prefix=True):
+            size = os.path.getsize(fpath)
+            if fpath in pfr['norm']:
+                data['pkgs_count'] += size
+                _add_size(data['pkgs_size'], pfr['norm'][fpath], size)
+            elif fpath in pfr['ghost']:
+                data['pkgs_ghost_count'] += size
+                _add_size(data['pkgs_ghost_size'], pfr['ghost'][fpath], size)
+            elif fpath in pfr['not']:
+                data['pkgs_not_count'] += size
+                _add_size(data['pkgs_not_size'], pfr['not'][fpath], size)
+                data['data_not_size'][fpath] = size
+            elif fpath in pfr['miss']:
+                data['pkgs_miss_count'] += size
+                _add_size(data['pkgs_miss_size'], pfr['miss'][fpath], size)
+            elif fpath in pfr['mod']:
+                data['pkgs_mod_count'] += size
+                _add_size(data['pkgs_mod_size'], pfr['mod'][fpath], size)
+            elif need_prefix and False:
+                for fpre_path in _dir_prefixes(fpath):
+                    if fpre_path not in pkg_files:
+                        continue
+                    _add_size(data['pres_size'], pkg_files[fpre_path], size)
+                    break
+                data['data_count'] += size
+                data['data_size'][fpath] = size
+            else:
+                data['data_count'] += size
+                data['data_size'][fpath] = size
+
+        prefix = "."
+        if extcmds:
+            prefix = extcmds[0]
+            extcmds = extcmds[1:]
+
+        if not os.path.exists(prefix):
+            return 1, [_('No such file or directory: ' + prefix)]
+
+        max_show_len = 4
+        if extcmds:
+            try:
+                max_show_len = int(extcmds[0])
+            except:
+                pass
+
+        verbose = base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
+
+        pfr = self._fs_pkg_walk(base.rpmdb, prefix, verbose=verbose)
+
+        base.closeRpmDB() # C-c ftw.
+
+        num = 0
+        if os.path.isfile(prefix):
+            num += 1
+            deal_with_file(prefix)
+
+        for root, dirs, files in os.walk(prefix):
+            for fname in files:
+                num += 1
+                fpath = os.path.normpath(root + '/' + fname)
+                if os.path.islink(fpath):
+                    continue
+
+                deal_with_file(fpath, need_prefix=verbose)
+
+        # output
+        print "Files            :", loc_num(num)
+        tot = 0
+        tot += data['pkgs_count']
+        tot += data['pkgs_ghost_count']
+        tot += data['pkgs_not_count']
+        tot += data['pkgs_miss_count']
+        tot += data['pkgs_mod_count']
+        tot += data['data_count']
+        print "Total size       :", base.format_number(tot)
+        if not tot:
+            return
+
+        num = data['pkgs_count']
+        if not verbose:
+            num += data['pkgs_ghost_count']
+            num += data['pkgs_miss_count']
+            num += data['pkgs_mod_count']
+        print "       Pkgs size :", "%-5s" % base.format_number(num),
+        print "(%3.0f%%)" % ((num * 100.0) / tot)
+        if verbose:
+            for (title, num) in ((_(" Ghost pkgs size :"),
+                                  data['pkgs_ghost_count']),
+                                 (_(" Not pkgs size :"),
+                                  data['pkgs_not_count']),
+                                 (_(" Miss pkgs size :"),
+                                  data['pkgs_miss_count']),
+                                 (_(" Mod. pkgs size :"),
+                                  data['pkgs_mod_count'])):
+                if not num:
+                    continue
+                print title, "%-5s" % base.format_number(num),
+                print "(%3.0f%%)" % ((num * 100.0) / tot)
+        num = data['data_count']
+        if not verbose:
+            num += data['pkgs_not_count']
+        print _("       Data size :"), "%-5s" % base.format_number(num),
+        print "(%3.0f%%)" % ((num * 100.0) / tot)
+        if verbose:
+            print ''
+            print _("Pkgs       :"), loc_num(len(data['pkgs_size']))
+            print _("Ghost Pkgs :"), loc_num(len(data['pkgs_ghost_size']))
+            print _("Not Pkgs   :"), loc_num(len(data['pkgs_not_size']))
+            print _("Miss. Pkgs :"), loc_num(len(data['pkgs_miss_size']))
+            print _("Mod. Pkgs  :"), loc_num(len(data['pkgs_mod_size']))
+
+        def _pkgs(p_size, msg):
+            tot = min(max_show_len, len(p_size))
+            if tot:
+                print ''
+                print msg % tot
+            num = 0
+            for pkg in sorted(p_size, key=lambda x: p_size[x], reverse=True):
+                num += 1
+                print _("%*d. %60s %-5s") % (len(str(tot)), num, pkg,
+                                             base.format_number(p_size[pkg]))
+                if num >= tot:
+                    break
+
+        if verbose:
+            _pkgs(data['pkgs_size'], _('Top %d packages:'))
+            _pkgs(data['pkgs_ghost_size'], _('Top %d ghost packages:'))
+            _pkgs(data['pkgs_not_size'], _('Top %d not. packages:'))
+            _pkgs(data['pkgs_miss_size'], _('Top %d miss packages:'))
+            _pkgs(data['pkgs_mod_size'], _('Top %d mod. packages:'))
+            _pkgs(data['pres_size'], _('Top %d prefix packages:'))
+        else:
+            tmp = {}
+            tmp.update(data['pkgs_size'])
+            for d in data['pkgs_ghost_size']:
+                _add_size(tmp, d, data['pkgs_ghost_size'][d])
+            for d in data['pkgs_miss_size']:
+                _add_size(tmp, d, data['pkgs_miss_size'][d])
+            for d in data['pkgs_mod_size']:
+                _add_size(tmp, d, data['pkgs_mod_size'][d])
+            _pkgs(tmp, _('Top %d packages:'))
+
+        print ''
+        if verbose:
+            data_size = data['data_size']
+        else:
+            data_size = {}
+            data_size.update(data['data_size'])
+            data_size.update(data['data_not_size'])
+
+        tot = min(max_show_len, len(data_size))
+        if tot:
+            print _('Top %d non-package files:') % tot
+        num = 0
+        for fname in sorted(data_size,
+                            key=lambda x: data_size[x],
+                            reverse=True):
+            num += 1
+            dsznum = data_size[fname]
+            print _("%*d. %60s %-5s") % (len(str(tot)), num, fname,
+                                         base.format_number(dsznum))
+            if num >= tot:
+                break
+
+    def _fs_filters(self, base, extcmds):
+        def _save(confkey):
+            writeRawConfigFile = yum.config._writeRawConfigFile
+
+            # Always create installroot, so we can change it.
+            if not os.path.exists(base.conf.installroot + '/etc/yum'):
+                os.makedirs(base.conf.installroot + '/etc/yum')
+
+            fn = base.conf.installroot+'/etc/yum/yum.conf'
+            if not os.path.exists(fn):
+                # Try the old default
+                nfn = base.conf.installroot+'/etc/yum.conf'
+                if os.path.exists(nfn):
+                    fn = nfn
+                else:
+                    shutil.copy2(base.conf.config_file_path, fn)
+            ybc = base.conf
+            writeRawConfigFile(fn, 'main', ybc.yumvar,
+                               ybc.cfg.options, ybc.iteritems,
+                               ybc.optionobj,
+                               only=[confkey])
+
+        if not extcmds:
+            oil = base.conf.override_install_langs
+            if not oil:
+                oil = "rpm: " + rpm.expandMacro("%_install_langs")
+            print _("File system filters:")
+            print _("  Nodocs:"), 'nodocs' in base.conf.tsflags
+            print _("  Languages:"), oil
+        elif extcmds[0] in ('docs', 'nodocs',
+                            'documentation', 'nodocumentation'):
+            c_f = 'nodocs' in base.conf.tsflags
+            n_f = not extcmds[0].startswith('no')
+            if n_f == c_f:
+                if n_f:
+                    print _("Already enabled documentation filter.")
+                else:
+                    print _("Already disabled documentation filter.")
+                return
+
+            if n_f:
+                print _("Enabling documentation filter.")
+            else:
+                print _("Disabling documentation filter.")
+
+            nts = base.conf.tsflags
+            if n_f:
+                nts = nts + ['nodocs']
+            else:
+                nts = [x for x in nts if x != 'nodocs']
+            base.conf.tsflags = " ".join(nts)
+
+            _save('tsflags')
+
+        elif extcmds[0] in ('langs', 'nolangs', 'lang', 'nolang',
+                            'languages', 'nolanguages',
+                            'language', 'nolanguage'):
+            if extcmds[0].startswith('no') or len(extcmds) < 2 or 'all' in extcmds:
+                val = 'all'
+            else:
+                val = ":".join(extcmds[1:])
+
+            if val == base.conf.override_install_langs:
+                if val:
+                    print _("Already filtering languages to: %s") % val
+                else:
+                    print _("Already disabled language filter.")
+                return
+
+            if val:
+                print _("Setting language filter to: %s") % val
+            else:
+                print _("Disabling language filter.")
+
+            base.conf.override_install_langs = val
+
+            _save('override_install_langs')
+
+        else:
+            return 1, [_('Not a valid sub-command of fs filter')]
+
+    def _fs_refilter(self, base, extcmds):
+        c_f = 'nodocs' in base.conf.tsflags
+        # FIXME: C&P from init.
+        oil = base.conf.override_install_langs
+        if not oil:
+            oil = rpm.expandMacro("%_install_langs")
+        if oil == 'all':
+            oil = ''
+        elif oil:
+            oil = ":".join(sorted(oil.split(':')))
+
+        found = False
+        num = 0
+        for pkg in base.rpmdb.returnPackages(patterns=extcmds):
+            if False: pass
+            elif oil != pkg.yumdb_info.get('ts_install_langs', ''):
+                txmbrs = base.reinstall(po=pkg)
+                num += len(txmbrs)
+            elif c_f != ('true' == pkg.yumdb_info.get('tsflag_nodocs')):
+                txmbrs = base.reinstall(po=pkg)
+                num += len(txmbrs)
+            else:
+                found = True
+
+        if num:
+            return 2,P_('%d package to reinstall','%d packages to reinstall',
+                        num)
+
+        if not found:
+            return 1, [_('No valid packages: %s') % " ".join(extcmds)]
+
+    def _fs_refilter_cleanup(self, base, extcmds):
+        pkgs = base.rpmdb.returnPackages(patterns=extcmds)
+
+        verbose = base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
+
+        pfr = self._fs_pkg_walk(pkgs, "/", verbose=verbose, modified=True)
+
+        base.closeRpmDB() # C-c ftw.
+
+        for fname in sorted(pfr['not']):
+            print _('Removing:'), fname
+            try: # Ignore everything, unlink_f() doesn't.
+                os.unlink(fname)
+            except OSError, e:
+                if e.errno == errno.EISDIR:
+                    try:
+                        os.rmdir(fname)
+                    except:
+                        pass
+            except:
+                pass
+
+    def _fs_diff(self, base, extcmds):
+        def deal_with_file(fpath):
+            if fpath in pfr['norm']:
+                pass
+            elif fpath in pfr['ghost']:
+                pass
+            elif fpath in pfr['not']:
+                print >>sys.stderr, _('Not installed:'), fpath
+            elif fpath in pfr['miss']:
+                pass
+            elif fpath in pfr['mod']:
+                pkg = apkgs[pfr['mod'][fpath].pkgtup]
+                # Hacky ... but works.
+                sys.stdout.flush()
+                extract_cmd = "cd %s; rpm2cpio %s | cpio --quiet -id .%s"
+                extract_cmd =  extract_cmd % (tmpdir, pkg.localPkg(), fpath)
+                os.system(extract_cmd)
+                diff_cmd = "diff -ru %s %s" % (tmpdir + fpath, fpath)
+                print diff_cmd
+                sys.stdout.flush()
+                os.system(diff_cmd)
+            else:
+                print >>sys.stderr, _('Not packaged?:'), fpath
+
+        if not distutils.spawn.find_executable("diff"):
+            raise yum.Errors.YumBaseError, _("Can't find diff command")
+        # These just shouldn't happen...
+        if not distutils.spawn.find_executable("cpio"):
+            raise yum.Errors.YumBaseError, _("Can't find cpio command")
+        if not distutils.spawn.find_executable("rpm2cpio"):
+            raise yum.Errors.YumBaseError, _("Can't find rpm2cpio command")
+
+        prefix = "."
+        if extcmds:
+            prefix = extcmds[0]
+            extcmds = extcmds[1:]
+
+        pkgs = base.rpmdb.returnPackages(patterns=extcmds)
+
+        verbose = base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
+
+        pfr = self._fs_pkg_walk(pkgs, prefix, verbose=verbose, modified=True)
+
+        base.closeRpmDB() # C-c ftw.
+
+        apkgs = {}
+        downloadpkgs = []
+        for ipkg in set(pfr['mod'].values()):
+            iyi = ipkg.yumdb_info
+            if 'from_repo' in iyi: # Updates-testing etc.
+                if iyi.from_repo in base.repos.repos:
+                    repo = base.repos.getRepo(iyi.from_repo)
+                    if not repo.isEnabled():
+                        base.repos.enableRepo(repo.id)
+
+            for apkg in base.pkgSack.searchPkgTuple(ipkg.pkgtup):
+                if ('checksum_type' in iyi and
+                    'checksum_data' in iyi and
+                    iyi.checksum_type == apkg.checksum_type and
+                    iyi.checksum_data == apkg.pkgId):
+                    apkgs[ipkg.pkgtup] = apkg
+                    downloadpkgs.append(apkg)
+                    break
+            if ipkg.pkgtup not in apkgs:
+                raise yum.Errors.YumBaseError, _("Can't find package: %s") %ipkg
+
+        if downloadpkgs:
+            tmpdir = tempfile.mkdtemp()
+            problems = base.downloadPkgs(downloadpkgs, callback_total=base.download_callback_total_cb) 
+            if len(problems) > 0:
+                errstring = ''
+                errstring += _('Error downloading packages:\n')
+                for key in problems:
+                    errors = yum.misc.unique(problems[key])
+                    for error in errors:
+                        errstring += '  %s: %s\n' % (key, error)
+                raise yum.Errors.YumBaseError, errstring
+
+        for root, dirs, files in os.walk(prefix):
+            for fname in files:
+                fpath = os.path.normpath(root + '/' + fname)
+                if os.path.islink(fpath):
+                    continue
+
+                deal_with_file(fpath)
+
+        if downloadpkgs:
+            shutil.rmtree(tmpdir)
+
+    def _fs_status(self, base, extcmds):
+        def deal_with_file(fpath):
+            if fpath in pfr['norm']:
+                pass
+            elif fpath in pfr['ghost']:
+                pass
+            elif fpath in pfr['not']:
+                print _('Not installed:'), fpath
+            elif fpath in pfr['miss']:
+                pass
+            elif fpath in pfr['mod']:
+                print _('Modified:'), fpath
+            else:
+                print _('Not packaged?:'), fpath
+
+        prefix = "."
+        if extcmds:
+            prefix = extcmds[0]
+            extcmds = extcmds[1:]
+
+        pkgs = base.rpmdb.returnPackages(patterns=extcmds)
+
+        verbose = base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
+
+        pfr = self._fs_pkg_walk(pkgs, prefix, verbose=verbose, modified=True)
+
+        base.closeRpmDB() # C-c ftw.
+
+        for root, dirs, files in os.walk(prefix):
+            for fname in files:
+                fpath = os.path.normpath(root + '/' + fname)
+                if os.path.islink(fpath):
+                    continue
+
+                deal_with_file(fpath)
+
+    def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+        if extcmds and extcmds[0] in ('filters', 'filter',
+                                      'refilter', 'refilter-cleanup',
+                                      'du', 'status', 'diff', 'snap'):
+            subcommand = extcmds[0]
+            extcmds = extcmds[1:]
+        else:
+            subcommand = 'filters'
+
+        if False: pass
+
+        elif subcommand == 'du':
+            ret = self._fs_du(base, extcmds)
+
+        elif subcommand in ('filter', 'filters'):
+            ret = self._fs_filters(base, extcmds)
+
+        elif subcommand == 'refilter':
+            ret = self._fs_refilter(base, extcmds)
+
+        elif subcommand == 'refilter-cleanup':
+            ret = self._fs_refilter_cleanup(base, extcmds)
+
+        elif subcommand == 'diff':
+            ret = self._fs_diff(base, extcmds)
+
+        elif subcommand == 'status':
+            ret = self._fs_status(base, extcmds)
+
+        elif subcommand == 'snap':
+            ret = FSSnapshotCommand().doCommand(base, 'fs snap', args)
+
+        else:
+            return 1, [_('Not a valid sub-command of %s') % basecmd]
+
+        if ret is not None:
+            return ret
+
+        return 0, [basecmd + ' ' + subcommand + ' done']
